QGIS Application - Bug report #7283
saveAsimage not including entire mapCanvas
2013-03-06 08:01 AM - Brian Edmond

Status: Closed

Priority: Normal

Assignee:

Category: Map Canvas

Affected QGIS version:1.8.0 Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied: Resolution: not reproducable
Crashes QGIS or corrupls data: Copied to github as #: 16293
Description

| have a plugin for exporting maps as PNG images. | believe this code was working correctly within 1.6 (but | cannot guarantee | haven't
made another change that would have broken it there, t00).

Basically, | load a set of base map features and then loop through a set of point layers that get applied and the whole thing is exported as
an image. I'm not getting the full canvas at all, but only a single attribute loaded from the base map and nothing from the point layers. (bad
result, expected result)

In the process of debugging this, | discovered a curious fact. If | include a QMessageBox.information right before | do the export, it works
correctly!

Doesn't work:

self.mapCanvas.resize(QSize(394,350))
self. mapCanvas.zoomToFullExtent()
currentimagePath = theExportPath + folder
currentimageName = attribute.replace(' ', '_") + ".png"
self.mapCanvas.saveAsImage(currentimagePath + "/" + currentimageName)

Does work:

self. mapCanvas.resize(QSize(394,350))
self.mapCanvas.zoomToFullExtent()
QMessageBox.information(self.iface.mainWindow(),"Debug","Break")
currentimagePath = theExportPath + folder

currentimageName = attribute.replace(' ', '_") + ".png"
self.mapCanvas.saveAsimage(currentimagePath + "/" + currentimageName)

| tried to add a simple self.iface.mainWindow() in place of the message box but that didn't do the trick. I'm thinking there is some kind of
refresh | could do, too, but | tried mapCanvas.refresh() and mapCanvas.updateMap() and these in combination with mainWindow() but

could get nothing to work.

Did this change in 1.8?7 Any suggestions to make it work? Including the QMessageBox call will get me going but | have to press "OK" for
each map to be exported. With all the export combinations, I'd be doing this more than 1000 times!

Thanks!

Reported as question at:
http://gis.stackexchange.com/questions/52563/mapcanvas-saveasimage-not-functioning-as-expected-in-qgis-1-8
http://gis.stackexchange.com/questions/52563/mapcanvas-saveasimage-not-functioning-as-expected-in-qgis-1-8

History

#1 - 2017-05-01 01:09 AM - Giovanni Manghi
- Easy fix? set to No
- Regression? set to No

#2 - 2018-03-01 12:24 PM - Giovanni Manghi

- Status changed from Open to Feedback

Please test with a recent QGIS release (2.18 or 3), if the issue/request is still valid change the affected version accordingly, if is fixed/implemented then

close the ticket. Thanks!

#3 - 2018-08-23 07:43 PM - Giovanni Manghi
- Resolution set to not reproducable

- Status changed from Feedback to Closed

- Description updated

Closing for lack of feedback.
